package com.microservices.zone.member.mapper;

import com.microservices.zone.member.domain.ZoneMemberType;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 特色专区会员分类Mapper接口
 *
 * @author otto
 * @date 2023-05-16
 */
@Mapper
public interface ZoneMemberTypeMapper {
    /**
     * 查询特色专区会员分类
     *
     * @param id 特色专区会员分类主键
     * @return 特色专区会员分类
     */
    public ZoneMemberType selectZoneMemberTypeById(Long id);

    /**
     * 查询特色专区会员分类列表
     *
     * @param zoneMemberType 特色专区会员分类
     * @return 特色专区会员分类集合
     */
    public List<ZoneMemberType> selectZoneMemberTypeList(ZoneMemberType zoneMemberType);

    /**
     * 新增特色专区会员分类
     *
     * @param zoneMemberType 特色专区会员分类
     * @return 结果
     */
    public int insertZoneMemberType(ZoneMemberType zoneMemberType);

    /**
     * 修改特色专区会员分类
     *
     * @param zoneMemberType 特色专区会员分类
     * @return 结果
     */
    public int updateZoneMemberType(ZoneMemberType zoneMemberType);

    /**
     * 删除特色专区会员分类
     *
     * @param id 特色专区会员分类主键
     * @return 结果
     */
    public int deleteZoneMemberTypeById(Long id);

    /**
     * 批量删除特色专区会员分类
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteZoneMemberTypeByIds(Long[] ids);

    /**
     * 通过Id检查专区下会员类型是否存在
     *
     * @param memberTypeId
     * @param zoneId
     * @return
     */
    ZoneMemberType selectZoneMemberTypeByIdAndZoneId(@Param("memberTypeId") Long memberTypeId, @Param("zoneId") Long zoneId);

    /**
     * 通过名称检查专区下会员类型是否存在
     *
     * @param name
     * @param zoneId
     * @return
     */
    List<ZoneMemberType> selectZoneMemberTypeListByNameAndZoneId(@Param("name") String name, @Param("zoneId") Long zoneId);

    /**
     * 根据名称和专区Id获取会员类型
     *
     * @param name
     * @param zoneId
     * @return
     */
    ZoneMemberType selectZoneMemberTypeByNameAndZoneId(@Param("name") String name, @Param("zoneId") Long zoneId);

    /**
     * 查询专区下最大序号
     *
     * @param zoneId
     * @return
     */
    Integer selectMaxSortByZoneId(Long zoneId);

    /**
     * 查询专区下总数量
     *
     * @param zoneId
     * @return
     */
    Integer selectCountByZoneId(Long zoneId);

    /**
     * 获取指定序号的数据
     *
     * @param data
     * @param order
     * @param isContainsSelf
     * @return
     */
    ZoneMemberType selectDataByOrderAndZoneId(@Param("data") ZoneMemberType data, @Param("order") Integer order, @Param("isContainsSelf") boolean isContainsSelf);

    /**
     * 查询专区下最小排序值
     *
     * @param zoneId
     * @return
     */
    int selectMinSortByZoneId(Long zoneId);

    /**
     * 批量增加大于指定排序的排序值
     *
     * @param zoneId
     * @param setSort
     * @return
     */
    Integer batchUpdateSortIncreased(@Param("zoneId") Long zoneId, @Param("setSort") Integer setSort);

    /**
     * 根据专区Id删除会员类别
     *
     * @param zoneId
     * @return
     */
    int deleteZoneMemberTypeByZoneId(Long zoneId);
}
